<a id="mypy-boto3-sqs"></a>

# mypy-boto3-sqs

[![PyPI - types-aiobotocore-sqs](https://img.shields.io/pypi/v/types-aiobotocore-sqs.svg?color=blue)](https://pypi.org/project/types-aiobotocore-sqs)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-sqs.svg?color=blue)](https://pypi.org/project/types-aiobotocore-sqs)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-sqs?color=blue)](https://pypistats.org/packages/types-aiobotocore-sqs)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.SQS 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/sqs.html#SQS)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-sqs docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_sqs/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-sqs](#mypy-boto3-sqs)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
    - [From conda-forge](#from-conda-forge)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
- [Explicit type annotations are optional here](#explicit-type-annotations-are-optional-here)
- [Type should be correctly discovered by mypy and IDEs](#type-should-be-correctly-discovered-by-mypy-and-ides)
- [Explicit type annotations are optional here](#explicit-type-annotations-are-optional-here)
- [Type should be correctly discovered by mypy and IDEs](#type-should-be-correctly-discovered-by-mypy-and-ides)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `SQS`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `SQS` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[sqs]'

# Lite version does not provide session.create_client overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[sqs]'

# standalone installation
python -m pip install types-aiobotocore-sqs
```

<a id="from-conda-forge"></a>

### From conda-forge

Installing `mypy-boto3-sqs` from the `conda-forge` channel can be achieved by
adding `conda-forge` to your channels with:

```bash
conda config --add channels conda-forge
conda config --set channel_priority strict
```

Once the `conda-forge` channel has been enabled, `mypy-boto3-sqs` can be
installed with:

```bash
conda install mypy-boto3-sqs
```

It is possible to list all of the versions of `mypy-boto3-sqs` available on
your platform with:

```bash
conda search mypy-boto3-sqs --channel conda-forge
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[sqs]` in your environment:
  `python -m pip install 'types-aiobotocore[sqs]'`

Both type checking and auto-complete should work for `SQS` service. No explicit
type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[sqs]` in your environment:
  `python -m pip install 'types-aiobotocore[sqs]'`

Both type checking and auto-complete should work for `SQS` service. No explicit
type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[sqs]` in your environment:
  `python -m pip install 'types-aiobotocore[sqs]'`
- Run `mypy` as usual

Type checking should work for `SQS` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[sqs]` in your environment:
  `python -m pip install 'types-aiobotocore[sqs]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `SQS` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SQSClient` provides annotations for `session.create_client("sqs")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSClient

session = get_session()
async with session.create_client("sqs") as client:
    client: SQSClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_sqs.paginator` module contains type annotations for all
paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSClient
from types_aiobotocore_sqs.paginator import (
    ListDeadLetterSourceQueuesPaginator,
    ListQueuesPaginator,
)

session = get_session()
async with session.create_client("sqs") as client:
    client: SQSClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_dead_letter_source_queues_paginator: ListDeadLetterSourceQueuesPaginator = client.get_paginator("list_dead_letter_source_queues")
        list_queues_paginator: ListQueuesPaginator = client.get_paginator("list_queues")
    ```




### Service Resource annotations

`SQSServiceResource` provides annotations for `aiobotocore.resource("sqs")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSServiceResource

session = get_session()
async with session.resource("sqs") as resource:
    resource: SQSServiceResource
    # now resource usage is checked by mypy and IDE should provide code auto-complete
````

### Other resources annotations

`types_aiobotocore_sqs.service_resource` module contains type annotations for
all resources.

```python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSServiceResource
from types_aiobotocore_sqs.service_resource import (
    Message,
    Queue,
)

session = get_session()
async with session.resource("sqs") as resource:
    resource: SQSServiceResource

<a id="explicit-type-annotations-are-optional-here"></a>

# Explicit type annotations are optional here
<a id="type-should-be-correctly-discovered-by-mypy-and-ides"></a>

# Type should be correctly discovered by mypy and IDEs
    my_message: Message = resource.Message(...)
    my_queue: Queue = resource.Queue(...)
```

### Collections annotations

`types_aiobotocore_sqs.service_resource` module contains type annotations for
all `SQSServiceResource` collections.

```python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSServiceResource
from types_aiobotocore_sqs.service_resource import (
    ServiceResourceQueuesCollection,
)

session = get_session()
async with session.resource("sqs") as resource:
    resource: SQSServiceResource

<a id="explicit-type-annotations-are-optional-here"></a>

# Explicit type annotations are optional here
<a id="type-should-be-correctly-discovered-by-mypy-and-ides"></a>

# Type should be correctly discovered by mypy and IDEs
    queues: sqs_resources.ServiceResourceQueuesCollection = resource.queues
```

### Literals

`types_aiobotocore_sqs.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_sqs.literals import (
    ListDeadLetterSourceQueuesPaginatorName,
    ListQueuesPaginatorName,
    MessageSystemAttributeNameForSendsType,
    MessageSystemAttributeNameType,
    QueueAttributeNameType,
    ServiceName,
    PaginatorName,
)

def check_value(value: ListDeadLetterSourceQueuesPaginatorName) -> bool:
    ...
```

### Typed dictionaries

`types_aiobotocore_sqs.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_sqs.type_defs import (
    AddPermissionRequestQueueTypeDef,
    AddPermissionRequestRequestTypeDef,
    BatchResultErrorEntryTypeDef,
    ChangeMessageVisibilityBatchRequestEntryTypeDef,
    ChangeMessageVisibilityBatchRequestQueueTypeDef,
    ChangeMessageVisibilityBatchRequestRequestTypeDef,
    ChangeMessageVisibilityBatchResultEntryTypeDef,
    ChangeMessageVisibilityBatchResultTypeDef,
    ChangeMessageVisibilityRequestMessageTypeDef,
    ChangeMessageVisibilityRequestRequestTypeDef,
    CreateQueueRequestRequestTypeDef,
    CreateQueueRequestServiceResourceTypeDef,
    CreateQueueResultTypeDef,
    DeleteMessageBatchRequestEntryTypeDef,
    DeleteMessageBatchRequestQueueTypeDef,
    DeleteMessageBatchRequestRequestTypeDef,
    DeleteMessageBatchResultEntryTypeDef,
    DeleteMessageBatchResultTypeDef,
    DeleteMessageRequestRequestTypeDef,
    DeleteQueueRequestRequestTypeDef,
    GetQueueAttributesRequestRequestTypeDef,
    GetQueueAttributesResultTypeDef,
    GetQueueUrlRequestRequestTypeDef,
    GetQueueUrlRequestServiceResourceTypeDef,
    GetQueueUrlResultTypeDef,
    ListDeadLetterSourceQueuesRequestRequestTypeDef,
    ListDeadLetterSourceQueuesResultTypeDef,
    ListQueueTagsRequestRequestTypeDef,
    ListQueueTagsResultTypeDef,
    ListQueuesRequestRequestTypeDef,
    ListQueuesResultTypeDef,
    MessageAttributeValueTypeDef,
    MessageSystemAttributeValueTypeDef,
    MessageTypeDef,
    PaginatorConfigTypeDef,
    PurgeQueueRequestRequestTypeDef,
    QueueMessageRequestTypeDef,
    ReceiveMessageRequestQueueTypeDef,
    ReceiveMessageRequestRequestTypeDef,
    ReceiveMessageResultTypeDef,
    RemovePermissionRequestQueueTypeDef,
    RemovePermissionRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    SendMessageBatchRequestEntryTypeDef,
    SendMessageBatchRequestQueueTypeDef,
    SendMessageBatchRequestRequestTypeDef,
    SendMessageBatchResultEntryTypeDef,
    SendMessageBatchResultTypeDef,
    SendMessageRequestQueueTypeDef,
    SendMessageRequestRequestTypeDef,
    SendMessageResultTypeDef,
    ServiceResourceMessageRequestTypeDef,
    ServiceResourceQueueRequestTypeDef,
    SetQueueAttributesRequestQueueTypeDef,
    SetQueueAttributesRequestRequestTypeDef,
    TagQueueRequestRequestTypeDef,
    UntagQueueRequestRequestTypeDef,
)

def get_structure() -> AddPermissionRequestQueueTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-sqs` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation

All type annotations can be found in
[types-aiobotocore-sqs docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_sqs/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
